#include <stddef.h>
#include <stdint.h>

#define KISS_MAX_DATAFRAMELEN(x) (3+2*(x))
/*
 *  Maximum length of KISS data frame for a payload with given length.
 */

size_t kiss_encode_dataframe(uint8_t *output, uint8_t *input, size_t length);
/*
 *  Encodes a chunk of data as KISS data frame starting with 0xC0 0x00 and
 *  ending with 0xC0.
 */

size_t kiss_decode(uint8_t *buffer);
/*
 *  Decodes a KISS frame (which must start with 0xC0 and end with 0xC0).
 *  A leading 0x00 byte is preserved. Result is stored in input buffer.
 */

