#include "qam.h"

#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

size_t reader(void *ctx, uint8_t *input, size_t length) {
  return fread(input, 1, length, stdin);
}

int main(int argc, char **argv) {
  qam_config_t config = QAM_DEFAULT_CONFIG;
  qam_demodulator_t *state;
  if (!qam_prepare_config(&config)) abort();
  state = qam_demodulator_create(&config, reader, NULL);
  if (!state) {
    fprintf(stderr, "Could not initialize demodulator\n");
    return 1;
  }
  while (!feof(stdin)) {
    if (qam_demodulator_run(state, 0)) {
      fwrite(state->output, sizeof(float), config.bits_per_symbol, stdout);
    }
    if (ferror(stdin) || ferror(stdout)) return 1;
  }
  return 0;
}
